<cfinclude template="config.cfm">
<cfset grid = createObject("component",request.dhtmlxConnectors["grid"]).init(request.dhtmlxConnectors["datasource"],request.dhtmlxConnectors["db_type"])>

<!---
<cfset grid.enable_log(variables,getCurrentTemplatePath() & "_debug.log")>
--->

<!--- set datasource name --->
<cfset dsn="task2">

<!--- get option lists for combo box --->
<cfquery name="getProductType" datasource="#dsn#">
	SELECT *
    FROM tbl_productType
</cfquery>

<cfquery name="getManufacturer" datasource="#dsn#">
	SELECT *
    FROM tbl_manufacturer
</cfquery>

<!--- set option lists for productType --->
<cfset productType = structNew()>
<cfloop query="getProductType">
	<cfset productType[#productTypeId#]="#productTypeName#">
</cfloop>
<cfset grid.set_options("productTypeId", productType)>

<!--- set option lists for manufacturer --->
<cfset manufacturer = structNew()>
<cfloop query="getManufacturer">
	<cfset manufacturer[#manufacturerId#]="#manufacturerName#">
</cfloop>
<cfset grid.set_options("manufacturerId",  manufacturer)>

<!--- user-created function
<cffunction name="colorRow">
	<cfargument name="row">
    <cfif ARGUMENTS.row.get_index() mod 2>
    	<cfset ARGUMENTS.row.set_row_color("red")>
    </cfif>
</cffunction>
--->
<cffunction name="myUpdate">
	<cfargument name="action">
    <cfquery name="updateManufacturer">
    	UPDATE tbl_printer 
        SET manufacturerId = ARGUMENTS.action.get_data('manufacturerId'),
        productTypeId = ARGUMENTS.action.get_data('productTypeId')
        WHERE productId = ARGUMENTS.action.get_id();
    </cfquery>
    <cfset ARGUMENTS.action.success()>
</cffunction>


<cfset grid.dynamic_loading(100)>
<!---<cfset grid.event.attach("beforeRender", colorRow)>--->
<cfset grid.event.attach("beforeUpdate", myUpdate)>

<!--- render the table --->
<!---
<cfsavecontent variable="query">
	SELECT productId, manufacturerName, productTypeName, isColor, productName, price, launchDate, maxVolume, notes
	FROM tbl_printer P, tbl_manufacturer M, tbl_ProductType PT
	WHERE P.manufacturerId = M.manufacturerId
	AND P.productTypeId = PT.productTypeId
</cfsavecontent> 
--->

<cfsavecontent variable="query">
	SELECT *, DATEDIFF(month, launchDate, GETDATE()) as ProductAge
    FROM tbl_printer
</cfsavecontent>

<!---<cfset grid.render_sql(#query#, "productId", "manufacturerName,productTypeName,isColor,productName,price,launchDate,maxVolume,notes")>--->
<!---<cfset grid.render_table("tbl_printer")>--->

<cfset grid.render_sql(#query#, "productId", "manufacturerId,productTypeId,isColor,productName,price,launchDate,ProductAge,maxVolume,notes")>

<!---
<cfif grid.is_select_mode()>
<cfset grid.render_sql(#query#, "productId", "manufacturerName,productTypeName,isColor,productName,price,launchDate,maxVolume,notes")>
<cfelse>
<cfset grid.render_table("tbl_printer")>
</cfif>
--->